> For the complete documentation index, see [llms.txt](https://docs.cybus.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.cybus.io/2-6-1/data-flows/service-commissioning-files/definitions.md).

# Definitions

Define reusable value blocks in a service commissioning file and reference them with the !ref or !merge functions.

Definitions allow you to reference blocks from within a service commissioning file. While they share similarities with parameters, definitions are designed for internal use only.

You can define values of any data type, including object types. These values can be referenced using the `!ref` or `!merge` functions.

## Example

In this example, we create a definition for default Modbus endpoint settings that we want to reference.

{% code lineNumbers="true" %}

```yaml
modbusEndpointDefaults:
  connectionId: !ref modbusConnection
  operation: subscribe
  interval: 1000
  address:
    fc: 3
    length: 2
```

{% endcode %}

When you reference this definition using `!ref modbusEndpointDefaults`, you get the following value:

{% code lineNumbers="true" %}

```yaml
connectionId: !ref modbusConnection
  operation: subscribe
  interval: 1000
  address:
    fc: 3
    length: 2
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.cybus.io/2-6-1/data-flows/service-commissioning-files/definitions.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
